﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace SilverlightSquare.Pelmanism {
	public class CardCollection : ReadOnlyCollection<CardInformation> {
		private CardCollection(List<CardInformation> list)
			: base(list) {
		}

		public static CardCollection Create() {
			List<CardInformation> cards = new List<CardInformation>();

			foreach (Suit suit in new Suit[] { Suit.Club, Suit.Dia, Suit.Hart, Suit.Spade }) {
				for (int i = 1; i < 14; i++) {
					cards.Add(new CardInformation() { Suit = suit, Rank = i, IsFrontSide = false });
				}
			}
			return new CardCollection(cards);
		}
	}
}
