﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace SilverlightSquare.Pelmanism
{
	public class CardInformation : INotifyPropertyChanged
	{

		private int rank_;
		public int Rank
		{
			get { return this.rank_; }
			set
			{
				if(value < 0 || value > 13){
					throw new InvalidOperationException();
				}
				
				if (this.rank_ != value)
				{
					this.rank_ = value;
					OnPropertyChanged("Rank");
				}
			}
		}


		private Suit suit_;
		public Suit Suit
		{
			get { return this.suit_; }
			set
			{
				if (this.suit_ != value)
				{
					this.suit_ = value;
					OnPropertyChanged("Suit");
				}
			}
		}


		private bool isFrontSide_;
		public bool IsFrontSide
		{
			get { return this.isFrontSide_; }
			set
			{
				if (this.isFrontSide_ != value)
				{
					this.isFrontSide_ = value;
					OnPropertyChanged("IsFrontSide");
				}
			}
		}

		private bool isLocked_;
		public bool IsLocked {
			get { return this.isLocked_; }
			set {
				if (this.isLocked_ != value) {
					this.isLocked_ = value;
					OnPropertyChanged("IsLocked");
				}
			}
		}
		
		public event PropertyChangedEventHandler PropertyChanged;

		protected void OnPropertyChanged(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
}
