﻿
using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace SilverlightSquare.Pelmanism.Data {

    public sealed class BooleanInverter : IValueConverter {

        object IValueConverter.Convert(object value, Type targetType, object parameter, CultureInfo culture) {
            if (targetType != typeof(bool)) {
                throw new ArgumentOutOfRangeException("targetType", "BooleanInverter can only convert to Boolean");
            }

            if (!(value is bool)) {
                throw new ArgumentOutOfRangeException("value", "BooleanInverter can only convert from Boolean");
            }

            return !(bool)value;
        }

        object IValueConverter.ConvertBack(object value, Type targetType, object parameter, CultureInfo culture) {
            if (targetType != typeof(bool)) {
                throw new ArgumentOutOfRangeException("targetType", "BooleanInverter can only convert to Boolean");
            }

            if (!(value is bool)) {
                throw new ArgumentOutOfRangeException("value", "BooleanInverter can only convert from Boolean");
            }

            return !(bool)value;
        }
    }
}
