﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverlightSquare.Pelmanism.Controls;
using System.Windows.Threading;

namespace SilverlightSquare.Pelmanism
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			CardSpace.ItemsSource = CardCollection.Create();
		}
		
		private List<CardInformation> selectItems = new List<CardInformation>();
		
		private void CardSpace_ItemSelectionChanged(object sender, ItemSelectionChangaedEventArgs e) {
			CardInformation info = CardSpace.ItemContainerGenerator.ItemFromContainer(e.Item) as CardInformation;
			if(info == null){
				return;
			}
			info.IsFrontSide = e.Item.IsSelected;
			if(info.IsFrontSide){
				selectItems.Add(info);
			}else{
				if(selectItems.Contains(info)){
					selectItems.Remove(info);
				}
			}
			if(selectItems.Count == 2){
				CardSpace.IsHitTestVisible = false;
				DispatcherTimer timer = new DispatcherTimer(){Interval = TimeSpan.FromMilliseconds(1000)};
				if (selectItems[0].Rank == selectItems[1].Rank) {
					CardSpace.GetContainer(selectItems[0]).IsLocked = selectItems[0].IsLocked = true;
					CardSpace.GetContainer(selectItems[1]).IsLocked = selectItems[1].IsLocked = true;
				}

				timer.Tick += (s,ev) => {
					CardSpace.IsHitTestVisible = true;
					timer.Stop();
					CardSpace.AllUnselect();
				};
				selectItems.Clear();
				timer.Start();
			}
		}		
	}
}
